# 基本信息

学校：合肥工业大学宣城校区

比赛方向：小型内核实现

队伍成员：陈灿，栗学渊、费博

指导老师：田卫东、周红鹃



# 完成情况

我们以开源项目xv6-riscv-k210为基础，对内核进行了全面的功能扩展和完善，并对用户使用体验进行了优化。在进程管理方面，实现了静态多级反馈队列调度算法，大幅提升任务调度的灵活性和效率，同时新增了信号机制以及 `execve`、`getppid`、`clone`、`waitpid` 等系统调用，增强了进程管理能力。在内存管理方面，引入了 `mmap` 和 `munmap` 系统调用，实现了内存映射功能，为用户进程提供了更灵活的内存使用方式。在文件管理方面，新增了 `dup2`、`openat`、`getdents64`、`unlinkat`、`mkdirat`、`chmod` 和 `chown` 系统调用，显著增强了文件操作的灵活性和权限管理功能。在用户使用体验方面，我们对 shell 进行了改进，新增了 tab 键命令补全功能，并实现了常用的用户命令如 `date`、`uname`、`pwd` 和 `touch`，极大地提升了用户的操作便利性。

这些功能扩展使系统从调度、内存、文件、用户交互等多方面实现了实用性和功能性的升级。



# 说明文档

内核原理分析：[开机启动](doc/原理分析-开机启动.md)、	[内存管理](doc/原理分析-内存管理.md)、	[系统调用](doc/原理分析-系统调用.md)

进程管理：	[静态多级反馈队列](doc/进程管理-实现静态多级反馈队列.md)、	[进程管理系统调用](doc/进程管理-系统调用.md)、	[信号机制](doc/进程管理-信号机制.md)

内存管理：	[内存映射](doc/内存管理-内存映射.md)

文件管理：	[文件管理系统调用](doc/文件管理-系统调用.md)

用户使用：	[用户程序](doc/用户使用-用户程序.md)、	[功能扩展-Tab补全](doc/用户使用-Tab补全.md)


# 启动环境
+ `k210` 开发板或者 `qemu-system-riscv64`
+ 编译器使用riscv64-linux-gnu或者riscv64-unknown-elf都可以，通过Makefile中的 TOOLPREFIX 变量进行选择

## 编译器
RISC-V GCC 编译链: [riscv-gnu-toolchain](https://github.com/riscv/riscv-gnu-toolchain.git)

## QEMU
使用qemu-system-misc 4.2    
Ubuntu20版使用sudo apt install qemu-system-misc 默认安装的就是4.2；     
Ubuntu20版以后的版本默认安装的qemu是高于4.2的版本，需要手动安装旧版本；     
可以参考https://zhuanlan.zhihu.com/p/651653021 教程进行，不过其中第三个包qemu安装链接过期了，需要手动到网站中下载   
从链接http://security.ubuntu.com/ubuntu/pool/main/q/qemu 中找到qemu-system-misc_4.2-3ubuntu6.30_amd64.deb下载，通过dpkg安装即可

## <a id="title_qemu">在 qemu-system-riscv64 模拟器上运行</a>
首先，确保 `qemu-system-riscv64` 已经下载到您的机器上并且加到了环境变量中；  
安装`qemu-system-misc`之后会自带`qemu-system-riscv64`   
其次，需要一个 FAT32 磁盘镜像文件；
```bash
make fs
```
这会生成一个镜像文件 `fs.img` ，编译一些用户程序（如 `shell`）并拷贝至镜像中。只要 `fs.img` 存在并且不需要修改，您不必每次运行前都执行这个命令。

最后，开始运行：
```bash
make run platform=qemu
```

Ps: 按 `Ctrl + A` 然后 `X` 退出 `qemu`。     

# 参考

[HUST-OS/xv6-k210](https://github.com/HUST-OS/xv6-k210)

[xv6操作系统教程](https://xv6.dgs.zone/)