## 启动过程
xv6 在 qemu 里面是没有使用 SBI 实现来启动的，这种情况下它的内核被放在地址 0x80000000 处，qemu 将内核加载后直接执行内核的第一行指令。  
这个第一行指令是在 kernel 目录下的汇编文件 entry.S 里面：  
```
    .section .text
    .globl _entry
_entry:
    add t0, a0, 1
    slli t0, t0, 14
    la sp, boot_stack
    add sp, sp, t0
    call main

loop:
    j loop

    .section .bss.stack
    .align 12
    .globl boot_stack
boot_stack:
    .space 4096 * 4 * 2
    .globl boot_stack_top
boot_stack_top:
```
在这个汇编文件里面内核会做一些准备工作，这里是会分配内核栈空间，每个核分配 4096 byte 的空间，这些准备工作完成之后，xv6 内核就切换到了 S 态去运行，并跳转到 main.c 文件中的 main 函数中执行。  

在 main 函数中会进行内核中各个模块比如内存管理，中断，进程管理的初始化。  

在 xv6 中，会先启动第 0 个核，在第 0 个核中初始化完成后，再去启动其他核，最后会进入多核调度过程。  
