struct rtcdate{
  uint second;
  uint minute;
  uint hour;
  uint day;
  uint month;
  uint year;
};

void convert_to_date(uint64 seconds, struct rtcdate *r) {
    const int SECONDS_PER_MINUTE = 60;
    const int SECONDS_PER_HOUR = 3600;
    const int SECONDS_PER_DAY = 86400;

    // 基准日期：2025-01-01（UNIX 时间）
    int year = 2025;
    int days_in_year;

    // 计算年份
    while (1) {
        days_in_year = (year % 4 == 0 && (year % 100 != 0 || year % 400 == 0)) ? 366 : 365;
        if (seconds < days_in_year * SECONDS_PER_DAY)
            break;
        seconds -= days_in_year * SECONDS_PER_DAY;
        year++;
    }
    r->year = year;

    // 计算月份
    const int days_in_month[] = {31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
    int month = 0;
    while (1) {
        int dim = days_in_month[month];
        if (month == 1 && days_in_year == 366)  // 闰年调整
            dim = 29;
        if (seconds < dim * SECONDS_PER_DAY)
            break;
        seconds -= dim * SECONDS_PER_DAY;
        month++;
    }
    r->month = month + 1;
    r->day = seconds / SECONDS_PER_DAY + 1;
    seconds %= SECONDS_PER_DAY;

    // 计算时分秒
    r->hour = seconds / SECONDS_PER_HOUR;
    seconds %= SECONDS_PER_HOUR;
    r->minute = seconds / SECONDS_PER_MINUTE;
    r->second = seconds % SECONDS_PER_MINUTE;
}
