#include "kernel/include/types.h"
#include "kernel/include/stat.h"
#include "xv6-user/user.h"


int main(int argc, char* argv[])
{

    if(argc!=2){
        printf("usage: priority_sta <fork number> \n");
	exit(0);
    }
    int forknumber=atoi(argv[1]);
    int status;

    for(int i=0;i<forknumber;i++)
    {
        printf("fork %d\n", i);
        status=fork();
        if(status)
		{
            printf("%d start to set priority\n",status);
	    	set_priority(status, (i+3)%4+1);   //在父进程中，将每个子进程的优先级设置为i%4+1.
            printf("%d set priority done\n", status);
        }
        if(status==0){
	    	for(int count=0;count<40; count++){
				printf(" ");
		    	for(int k=0;k<1000000;k++){
					int result=0;
					for( int j=0; j<5000; j++){
			    		result+=j*j;
                        result-=j*j;
                        result= result/j;
                        result=result*j;
                        result = result+result/j;
					}
		   		}
            }
            
            exit(0);
        }
    }
    int rutime;
    int retime;
    int sltime;
    int pid;
    int sum=0;
    while((pid = waitsch(&rutime,&retime,&sltime))!=-1){
        sum+= rutime+retime+sltime;
    }
    printf(" average turn-around time of %d process is %d\n", forknumber, sum/forknumber);
    exit(0);


}