#include "kernel/include/types.h"
#include "kernel/include/stat.h"
#include "xv6-user/user.h"


int main() {
  // 创建测试文件
  int fd = open("testfile", O_CREATE | O_RDWR);
  if (fd < 0) {
    printf("Failed to create file\n");
    exit(1);
  }
  close(fd);

  // 修改文件权限
  if (chmod("testfile", 0755) < 0) {
    printf("chmod failed\n");
    exit(1);
  }
  printf("Changed file mode to 0755\n");

  // 修改文件拥有者
  if (chown("testfile", 1000, 1000) < 0) {
    printf("chown failed\n");
    exit(1);
  }
  printf("Changed file owner to uid=1000, gid=1000\n");

  //printf("AAAAA\n");
  // 获取文件状态
  struct stat st;
  if (stat("testfile", &st) < 0) {
    printf("stat failed\n");
    exit(1);
  }
  //printf("BBBBB\n");
  printf("File mode: %d, uid: %d, gid: %d\n", st.mode, st.uid, st.gid);

  exit(0);
}
