#include "xv6-user/user.h"

void thread_func() {
    printf("Thread Hello from thread!\n");
    thread_exit(); // 退出线程
}

int main() {
    int arg = 42;
    void *stack = malloc(4096); // 分配线程栈
    if (stack == NULL) {
        printf("Failed to allocate stack\n");
        exit(1);
    }

    // 手动对齐到 16 字节
    uint64 aligned_stack = ((uint64)stack + 4096) & ~0xF;
    // 打印分配的栈地址
    printf("main: allocated stack address = %d\n", aligned_stack);
    //printf("func adress= %d\n",(uint64)thread_func);

    if (aligned_stack % 128 != 0 ) {
        printf("Stack not aligned\n");
        free(stack);
        exit(1);
    }
    int pid = clone((void *)aligned_stack,thread_func,&arg); // 创建线程
    if (pid < 0) {
        printf("clone failed\n");
        free(stack);
        exit(1);
    }
    printf("wait thread\n");
    //等待线程退出
    // if (thread_join(pid) < 0) {
    //     printf("thread_join failed\n");
    //     free(stack);
    //     exit(1);
    // }

    printf("Thread %d finished\n", arg);
    free(stack); // 释放线程栈
    exit(0);
}
