#include "kernel/include/types.h"
#include "xv6-user/user.h"

int main(int argc, char* argv[]) {
    //int pid;
    int childpid;

    // 获取当前进程 ID
    int mypid = getpid();
    printf("Parent process: getpid() = %d\n", mypid);

    // 创建子进程
    childpid = fork();
    if (childpid > 0) { // 父进程
        //

        // 等待子进程退出
        waitpid(childpid, 0, 0);
        printf("Parent: forked child process with pid = %d\n", childpid);
        printf("Parent process: getppid() = %d\n", getppid());
        printf("Parent process: child exited, parent exiting...\n");
        exit(0);

    } else if (childpid == 0) { // 子进程
        printf("Child process: getpid() = %d\n", getpid());
        printf("Child process: getppid() = %d\n", getppid());
        printf("Child process exiting...\n");
        exit(0);

    } else { // 错误
        printf("Error: fork() failed, childpid < 0\n");
        exit(1);
    }

    return 0; // 这里一般不会执行到
}
